	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

mb_column_1		= $C0
mb_column_2		= $C1
scroll_x		= $C2
lower_scroll_text_ptr	= $C4
big_letter_src_ptr	= $C6
title_column_1		= $C8
title_column_2		= $C9

src			= $D0
dst_col			= $D2
dst_chr			= $D4
green_text_src		= $D6
dycp_chr		= $D8

sine_bit		= $0200
sine_lo			= $0300
sine_hi			= $0400

start
	sei
	sta $ff3f
	jmp skip_compressed_data
decompress
	include "../title_docs/title_comp1_hex.asm"
	include "../title_docs/title_comp2_hex.asm"
	db 0,0,0

skip_compressed_data
	ldx #$FF
	lda $FF07
	and #$40
	beq pal
	ldx #$F7
pal	;
	lda $FF19
	and #$70
	ora #$01
	;
ff_1	cpx $FF1D
	bne *-3
	;
	sta $FF19
	sta $FF15
	;
	ldy #$0B
	sty $FF06
	;
	ldy $FF1D
	cpy $FF1D
	beq *-3
	;
	cmp #$00
	beq ff_2
	;
	sec
	sbc #$10
	bpl *+4
	lda #$00
	jmp ff_1
	;
ff_2	ldx $02
	beq ff_3
	;
	jmp quit_2
	;
ff_3	tay
cls1	sta $0800,y
	sta $0900,y
	sta $0A00,y
	sta $0B00,y
	sta $0C00,y
	sta $0D00,y
	sta $0E00,y
	sta $0F00,y
	iny
	bne cls1
	;
	lda #$00
	sta $FF12
	lda #fonts >> 8
	sta $FF13
	;
	lda #$71
	sta $FF16
	lda #$46
	sta $FF17
	;
	lda #$FF
	sta $FF0C
	sta $FF0D
	;
	lda #$00
	sta scroll_x
	lda #lower_scroll_text & 255
	sta lower_scroll_text_ptr
	lda #lower_scroll_text >> 8
	sta lower_scroll_text_ptr+1
	;
	jsr PLAYER_INIT
	jsr init_timeline
	jsr dycp_init
	;
	; --- uncomment for testing
	;
;	jsr write_green_line_setup
;	jsr write_green_line
;	jsr write_green_line
;	jsr write_green_line
;	jsr write_green_line
;	jsr write_green_line
;	jsr write_green_line
;	jsr clear_10_columns_setup
;	jsr clear_10_columns
;	jsr clear_10_columns
;	jsr clear_10_columns
;	jsr disable_scroll
;	jsr disable_logo_and_font_swap
;	jsr fill_with_inverse_setup
;	jsr fill_with_inverse
;	jsr fill_with_inverse
;	jsr fill_with_inverse
	;
	lda #$CC
	cmp $FF1D
	bne *-3  
	lda #$1B
	sta $FF06
	asl $FF09
	;
	cli
	;
main	
dycp_top_call	
	bit dycp_top
mb_logo_swap_call
	jsr mb_logo_swap
font_swap_call
	jsr font_swap
legion_logo_on_call
	bit legion_logo_on
legion_color_call
	bit legion_color
scroll_set_call
	jsr scroll_set
	;
	lda #$CB
	cmp $FF1D
	bcs *-3
	;
	jsr quit_check
	;
;	ldy #$00				; for testing, "show" snare
;	lda $24					; digi addr
;	cmp #snar
;	bcc *+4
;	ldy #$77
;	sty $FF19
	;
top_font
	lda #fonts >> 8
	sta $FF13
	;
	lda $FF07
	and #$40
	ora #$98
	sta $FF07
	;
	;dec $FF19
	jsr process_timeline
	;inc $FF19
	;
green_flash_call
	jsr green_flash
	;
logo_flash_call
	bit logo_flash
	;
big_letter_flash_call
	bit big_letter_flash
	;
scroll_call
	bit do_scroll
	;
dycp_call
	bit dycp_render
	;
	lda #$CB
	cmp $FF1D
	bcc *-3
	;
	jmp main

quit_check
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10				; Query keyboard for "Space"
	beq quit
	;
	lda #$FF				; chec
	sta $FD30
	ldx #$FD
	stx $FF08
	lda $FF08
	cmp #$FF
	bne quit
	;
	lda #$FF
	sta $FD30
	ldx #$FB
	stx $FF08
	lda $FF08
	cmp #$FF
	bne quit
	rts
	;
quit
	lda #$00
	sta $02
quit_2
	sei
	;
	lda #$A2
	sta $FF0A
	;
	lda #$0B
	sta $FF06
	;
	lda #$00 
	sta $FF11
	tax
	tay
	jmp decompress

dycp_top
	lda #$FE
	cmp $FF1C
	bne *-3
	lda #$05
	cmp $FF1D
	bcs *-3
	;
	lda #dycp_font >> 8
	sta $FF13
	;
	lda $FF07
	and #$40
	ora #$80
	ora scroll_x
	sta $FF07
	;
	rts

mb_logo_swap
	lda #$FE
	cmp $FF1C
	bne *-3
	lda #$20
	cmp $FF1D
	bcs *-3
	lda #mb_logo_charset >> 8
	sta $FF13
	rts

font_swap
	lda #$FE
	cmp $FF1C
	bne *-3
font_swap_rasterline
	lda #$98
	cmp $FF1D
	bcs *-3
	;
	lda #fonts >> 8
	sta $FF13
	;
	lda $FF07
	and #$40
font_swap_color_mode
	ora #$88
	sta $FF07
	;
	rts
	
disable_logo_and_font_swap
	lda #$2C
	sta mb_logo_swap_call
	sta font_swap_call
	sta logo_flash_call
	rts 

scroll_set
	ldx #$B8
	cpx $FF1D
	bcs *-3 
	;
	lda $FF07
	and #$40
	ora #$80
	ora scroll_x
	sta $FF07
	rts

no_scroll_step
	sta scroll_x
	rts	
do_scroll
	ldx #39
scroll_color_index
	ldy #$00
scr2	lda scroll_colors,y
	sta $0800 + 23 * 40, x
	sta $0800 + 24 * 40, x
	iny
	dex
	bpl scr2
	;
	lda scroll_color_index+1
	clc
	adc #$01
	cmp #28
	bne *+4
	lda #$00
	sta scroll_color_index+1
	;
	lda scroll_x
	sec
scroll_speed
	sbc #$08
	bpl no_scroll_step
	;
	and #$07
	sta scroll_x
	ldx #$01
scr1	lda $0C00 + 23 * 40 + 1, x
	sta $0C00 + 23 * 40 + 0, x
	lda $0C00 + 24 * 40 + 1, x
	sta $0C00 + 24 * 40 + 0, x
	inx
	cpx #39
	bne scr1
	;
	ldy #$00
get_next_char
	lda (lower_scroll_text_ptr),y
	bpl not_control_character
	and #$07
	sta scroll_speed+1
	;
	inc lower_scroll_text_ptr
	bne *+4
	inc lower_scroll_text_ptr+1
	jmp get_next_char
	;
not_control_character
	ora #$80
	sta $0C00 + 23 * 40 + 39
	ora #$40
	sta $0C00 + 24 * 40 + 39
	;
	inc lower_scroll_text_ptr
	bne *+4
	inc lower_scroll_text_ptr+1
	;
	rts
	
enable_scroll
	lda #$20
	sta scroll_call
	rts

disable_scroll
	lda #$2C
	sta scroll_call
	sta scroll_set_call
	rts
	
scroll_colors
	db $02,$12,$22,$22,$32,$32,$48,$48,$58,$59,$69,$69,$77
	db $77,$69,$69,$59,$58,$48,$48,$32,$32,$22,$22,$12,$02
	db $02,$12,$22,$22,$32,$32,$48,$48,$58,$59,$69,$69,$77
	db $77,$69,$69,$59,$58,$48,$48,$32,$32,$22,$22,$12,$02
	db $02,$12,$22,$22,$32,$32,$48,$48,$58,$59,$69,$69,$77
	db $77,$69,$69,$59,$58,$48,$48,$32,$32,$22,$22,$12,$02

copy_mb_columns_setup
	ldy #(32 / 2) - 1			; width: 32 chars
	sty mb_column_1
	iny
	sty mb_column_2
	bne cmc1
	;
copy_mb_columns
	dec mb_column_1
	inc mb_column_2
	;
cmc1	ldy mb_column_1
	jsr copy_mb_column
	;
	ldy mb_column_2
	;
copy_mb_column
	lda #($0C00 + 5 * 40 + (40-32)/2) & 255
	sta dst_col
	sta dst_chr
	lda #($0C00 + 5 * 40 + (40-32)/2) >> 8
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	;
	lda #mb_logo_charmap & 255
	sta src
	lda #mb_logo_charmap >> 8
	sta src+1
	;
	ldx #12-1				; heights: 12 chars
cl1	lda (src),y
	sta (dst_chr),y
	lda #$1E
	sta (dst_col),y
	;
	lda dst_col
	clc
	adc #40
	sta dst_col
	sta dst_chr
	bcc *+6
	inc dst_col+1
	inc dst_chr+1
	;
	lda src
	clc
	adc #32					; width
	sta src
	bcc *+4
	inc src+1
	;
	dex
	bpl cl1
	;
ret1	rts

logo_flash
	ldx #$FF
	inx
logo_flash_speed
	cpx #8*7
	bne *+4
	ldx #$00
	stx logo_flash+1
	;
	cpx #7
	bcs ret1
	;
	lda logo_flash_ff16,x
	sta $FF16
	lda logo_flash_ff17,x
	sta $FF17
	rts

logo_flash_ff16
	db $16,$26,$36,$46,$56,$66,$71
logo_flash_ff17
	db $16,$16,$26,$26,$36,$36,$46

enable_logo_flash
	lda #$20
	sta logo_flash_call
	rts

speedup_logo_flash
	lda #1*7
	sta logo_flash_speed+1
	rts

big_letter_flash
	ldx #$FF
	inx
big_letter_flash_speed
	cpx #8*7
	bne *+4
	ldx #$00
	stx big_letter_flash+1
	;
	cpx #7
	bcs ret2
	;
	lda big_letter_flash_ff15,x
	sta $FF15
ret2	rts

big_letter_flash_ff15
	db $02,$12,$22,$32,$48,$59,$67

green_flash
	ldx #$FF
	inx
	cpx #$04
	bne *+4
	ldx #$00
	stx green_flash+1
	cpx #$04
	bcs ret2
	;
	lda green_flash_pos_lo,x		; get screen address
	sta dst_col
	lda green_flash_pos_hi,x
	sta dst_col+1
	;
	lda green_flash_index,x			; get color
	clc
	adc #$01
	cmp #10
	bne *+4
	lda #$00
	sta green_flash_index,x
	tax
	lda green_flash_colors,x
	;
	ldy #39
gf_1	sta (dst_col),y				; fill line
	dey
	bpl gf_1
	rts

green_flash_index
	db 6,4,2,0

green_flash_pos_lo
	db ($0800 + 0 * 40) & 255
	db ($0800 + 2 * 40) & 255
	db ($0800 + 19 * 40) & 255
	db ($0800 + 21 * 40) & 255
green_flash_pos_hi
	db ($0800 + 0 * 40) >> 8
	db ($0800 + 2 * 40) >> 8
	db ($0800 + 19 * 40) >> 8
	db ($0800 + 21 * 40) >> 8
	
green_flash_colors
	db $05,$25,$35,$45,$55
	db $65,$55,$45,$35,$25

write_green_line_setup
	lda #green_text & 255
	sta green_text_src
	lda #green_text >> 8
	sta green_text_src+1
	;
write_green_line
	ldy #$00
	lda (green_text_src),y
	sta dst_chr
	sta dst_col
	iny
	lda (green_text_src),y
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	iny
	;
wgl_1	lda (green_text_src),y
	bmi wgl_2
	sta (dst_chr),y
	inc dst_chr
	bne *+4
	inc dst_chr+1
	ora #$40
	sta (dst_chr),y
	lda #$65
	sta (dst_col),y
	inc dst_col  
	bne *+4
	inc dst_col+1
	sta (dst_col),y
	iny
	bne wgl_1
wgl_2	iny
	tya
	clc
	adc green_text_src
	sta green_text_src
	bcc *+4
	inc green_text_src+1 
	rts

green_line_copy_1
	ldx #($0C00 + 12*40 + 7) & 255
	lda #($0C00 + 12*40 + 7) >> 8
	ldy #24
	bne green_copy_left
	;
green_line_copy_3
	ldx #($0C00 + 13*40 + 6) & 255
	lda #($0C00 + 13*40 + 6) >> 8
	ldy #26
	bne green_copy_left
	;
green_line_copy_5
	ldx #($0C00 + 17*40 + 4) & 255
	lda #($0C00 + 17*40 + 4) >> 8
	ldy #30
	bne green_copy_left
	;
green_line_copy_7
	ldx #($0C00 + 18*40 + 2) & 255
	lda #($0C00 + 18*40 + 2) >> 8
	ldy #34
	bne green_copy_left
	;
green_copy_left
	stx dst_chr
	stx dst_col
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	;
	sty glc_l1+1
	sty glc_l2+1
	;
	ldy #0
glc_1	iny
	lda (dst_chr),y
	dey
	sta (dst_chr),y
	lda #$45
	sta (dst_col),y
	iny
glc_l1	cpy #24
	bne glc_1
	;
	lda #$00
	sta (dst_chr),y
	rts

green_copy_right
	; pointers should be already set
glc_l2	ldy #24
glc_2	lda (dst_chr),y
	iny
	sta (dst_chr),y
	lda #$65
	sta (dst_col),y
	dey
	dey
	bpl glc_2
	;
	lda #$00
	iny
	sta (dst_chr),y
	rts
	
color_green_1
	ldx #$21
	db $2C
color_green_2
	ldx #$43
	db $2C
color_green_3
	ldx #$65
	;
	ldy #$00
cg_2	lda (dst_chr),y
	cmp #$1B
	beq cg_3
	;
	lda dst_chr
	bne *+6
	dec dst_chr+1
	dec dst_col+1
	dec dst_chr
	dec dst_col
	jmp cg_2 
	;
cg_3	ldy #38
cg_1	lda (dst_chr),y
	cmp #$1B
	beq cg_4
	;
	txa
	sta (dst_col),y
cg_4	dey
	bpl cg_1
	;
cg_x	rts

write_green_line_gray
	jsr write_green_line
	;
	lda #$21
	ldx #27
wglg_1	sta $0800 + 15*40 + 6,x
	dex
	bpl wglg_1
	;
gray_color_highlight
	ldx #$00
gray_color_len
	ldy #$02
	;
gray_highlight_color
	lda #$75
	;
gch_1	sta $0800 + 15*40 + 6,x
	inx
	dey
	bne gch_1
	;
	lda gray_highlight_color+1
	eor #$10
	sta gray_highlight_color+1
	;
	rts

gray_color_highlight_2_4
	lda #$04
	sta gray_color_len+1
	bne gray_color_highlight_2
gray_color_highlight_4
	lda #$04
	db $2C
gray_color_highlight_2
	lda #$02
	clc
	adc gray_color_highlight+1
	sta gray_color_highlight+1
	bne gray_color_highlight		; always jump

clear_10_columns_setup
	lda #$00
	sta clear_10_columns+1
	;	
clear_10_columns
	lda #$00
	sta dst_col
	lda #$08
	sta dst_col+1
	;
	ldx #24
c10c_2	ldy #9
	lda #$00
c10c_1	sta (dst_col),y				; color mem only
	dey
	bpl c10c_1
	;
	lda dst_col
	clc
	adc #40
	sta dst_col
	bcc *+4
	inc dst_col+1 
	;
	dex
	bpl c10c_2
	;
	lda clear_10_columns+1
	clc
	adc #10
	sta clear_10_columns+1
	;
	lda #$2C				; disable the green flash
	sta green_flash_call
	;
	rts

;write_lower_text
;	ldy #$00
;wlt_1	lda lower_text,y
;	beq wlt_2
;	ora #$80
;	sta $0C00 + 23 * 40,y
;	ora #$40
;	sta $0C00 + 24 * 40,y
;	iny
;	bne wlt_1
;wlt_2	rts

green_text
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	;dw $0C00
	;db "INTRO NOT DONE YET",$FF
	
	dw $0C00 + 0 * 40 + (40 - 16 * 2)/2 - 2
	db "ALL THE WAY BACK",$FF
	dw $0C00 + 2 * 40 + (40 - 7 * 2)/2 - 2
	db "IN 1990",$FF
	dw $0C00 + 19 * 40 + (40 - 8 * 2)/2 - 2
	db "RELEASED",$FF
	dw $0C00 + 21 * 40 - 2
	db "INTO",$FF
	dw $0C00 + 21 * 40 + 7
	db "THE",$FF
	dw $0C00 + 21 * 40 + 15
	db "EAGLE'S",$FF
	dw $0C00 + 21 * 40 + 30
	db "NEST",$FF
	;
	; ---
	;
	;  |01234567890123456789
	dw $0C00 + 11 * 40 + (40 - 12 * 2)/2 - 2
	db "FIXED COLORS",$FF
	dw $0C00 + 12 * 40 + (40 - 12 * 2)/2 - 2
	db "TITLE SCREEN",$FF
	dw $0C00 + 13 * 40 + (40 - 13 * 2)/2 - 2
	db "PROPER SOUNDS",$FF
	dw $0C00 + 14 * 40 + (40 - 13 * 2)/2 - 2
	db "DOCUMENTATION",$FF
	dw $0C00 + 15 * 40 + (40 - 14 * 2)/2 - 2
	db "IMPROVED MUSIC",$FF
	dw $0C00 + 16 * 40 + (40 - 15 * 2)/2 - 2
	db "EXPLOSION FLASH",$FF
	dw $0C00 + 17 * 40 + (40 - 15 * 2)/2 - 2
	db "NTSC COMPATIBLE",$FF
	dw $0C00 + 18 * 40 + (40 - 17 * 2)/2 - 2
	db "NEW PLAYER SPRITE",$FF
	dw $0C00 + 19 * 40 + (40 - 17 * 2)/2 - 2
	db "GARBLED MAP FIXED",$FF
	dw $0C00 + 20 * 40 + (40 - 17 * 2)/2 - 2
	db "KEYBOARD CONTROLS",$FF
	dw $0C00 + 21 * 40 + (40 - 18 * 2)/2 - 2
	db "12 BUILT-IN CHEATS",$FF
	dw $0C00 + 22 * 40 + (40 - 18 * 2)/2 - 2
	db "PRISONER BUG FIXED",$FF
	dw $0C00 + 23 * 40 + (40 - 19 * 2)/2 - 2
	db "AUTODETECT JOY PORT",$FF
	dw $0C00 + 24 * 40 + (40 - 17 * 2)/2 - 2
	db "AND SO MUCH MORE!",$FF
	;
lower_scroll_text
	db "WH",$87,"IC",$86,"H ",$85,"HA",$84,"D ",$83,"A ",$82,"VERY COOL INTRO, INCLUDING RASTERS + DIGI!"
	db "   IT WAS A NICE RELEASE FOR ITS TIME, THE EARLY DAYS OF THE PLUS/4 SCENE..."
	db $83,"       "
	db $84,"       "
	db $85,"       "
	db $86,"       "
	db $87,"       "
	db "       "
	db "       "
	cmap

fill_with_inverse_setup
	lda #$00
	sta dst_chr
	lda #$0C
	sta dst_chr+1
	;
fill_with_inverse
	ldy #$00
	;
	lda #$1B				; inverse char
fwi_1	sta (dst_chr),y				; one page a time
	iny
	bne fwi_1
	;
	inc dst_chr+1
	;
	rts
	
disable_big_letter_flash
	lda #$2C
	sta big_letter_flash_call
	rts

enable_flash_write_big_letter
	lda #$20
	sta big_letter_flash_call
	bne write_big_letter			; always jump
	;
write_big_letter_setup
	lda #big_letters & 255
	sta big_letter_src_ptr
	lda #big_letters >> 8
	sta big_letter_src_ptr+1
	;
	lda big_letter_flash_ff15+6
	sta $FF15
	;
	jsr write_big_letter			; "write_big_letter_setup" actually writes two characters
	;
write_big_letter
	ldy #$00
	lda (big_letter_src_ptr),y
	sta dst_col
	sta dst_chr
	iny
	lda (big_letter_src_ptr),y
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	iny
	lda (big_letter_src_ptr),y
	sta src
	iny
	lda (big_letter_src_ptr),y
	sta src+1
	iny
	;
	tya
	clc
	adc big_letter_src_ptr
	sta big_letter_src_ptr
	bcc *+4
	inc big_letter_src_ptr+1 
	;
	ldx #6
wbl_1	ldy #5
wbl_2	lda (src),y
	sta (dst_chr),y
	dey
	bpl wbl_2
	;
	lda src
	clc
	adc #6
	sta src
	bcc *+4
	inc src+1
	;
	lda dst_chr
	clc
	adc #40
	sta dst_chr
	bcc *+4
	inc dst_chr+1
	;
	dex
	bpl wbl_1
	;
	rts
	
write_2_big_letters
	jsr write_big_letter
	jmp write_big_letter

erase_big_letter_setup
	lda #big_letters & 255
	sta big_letter_src_ptr
	lda #big_letters >> 8
	sta big_letter_src_ptr+1
	;
erase_big_letter
	ldy #$00
	lda (big_letter_src_ptr),y
	sta dst_col
	sta dst_chr
	iny
	lda (big_letter_src_ptr),y
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	iny
	iny
	iny
	;
	tya
	clc
	adc big_letter_src_ptr
	sta big_letter_src_ptr
	bcc *+4
	inc big_letter_src_ptr+1 
	;
	ldx #6
ebl_1	ldy #5
	lda #$1B				; inverse char
ebl_2	sta (dst_chr),y
	dey
	bpl ebl_2
	;
	lda src
	clc
	adc #6
	sta src
	bcc *+4
	inc src+1
	;
	lda dst_chr
	clc
	adc #40
	sta dst_chr
	bcc *+4
	inc dst_chr+1
	;
	dex
	bpl ebl_1
	;
	rts

erase_3_big_letters
	jsr erase_big_letter
erase_2_big_letters
	jsr erase_big_letter
	jmp erase_big_letter

big_letters
	dw $0C00 + 1 * 40 + 13, big_3
	dw $0C00 + 1 * 40 + 21, big_3
	
	dw $0C00 + 9 * 40 +  3, big_y
	dw $0C00 + 9 * 40 + 10, big_e
	dw $0C00 + 9 * 40 + 17, big_a
	dw $0C00 + 9 * 40 + 24, big_r
	dw $0C00 + 9 * 40 + 31, big_s

	dw $0C00 + 17 * 40 +  3, big_l
	dw $0C00 + 17 * 40 + 10, big_a
	dw $0C00 + 17 * 40 + 17, big_t
	dw $0C00 + 17 * 40 + 24, big_e
	dw $0C00 + 17 * 40 + 31, big_r
	
	; ---
	dw $0C00 + 17 * 40 + 31, big_r_empty
	dw $0C00 + 1 * 40 + 13, big_3_empty
	dw $0C00 + 1 * 40 + 21, big_3_empty
	dw $0C00 + 1 * 40 + 13, big_3
	dw $0C00 + 1 * 40 + 21, big_3
	dw $0C00 + 9 * 40 + 17, big_a_empty
	dw $0C00 + 17 * 40 + 10, big_a_empty
	dw $0C00 + 9 * 40 + 17, big_a
	dw $0C00 + 17 * 40 + 10, big_a
	;
	; - last bar
	dw $0C00 + 1 * 40 + 13, big_3_empty
	dw $0C00 + 1 * 40 + 21, big_3_empty
	dw $0C00 + 9 * 40 + 10, big_e_empty
	dw $0C00 + 9 * 40 + 17, big_a_empty
	dw $0C00 + 9 * 40 + 24, big_r_empty
	dw $0C00 + 17 * 40 + 10, big_a_empty
	dw $0C00 + 17 * 40 + 24, big_e_empty
	dw $0C00 + 1 * 40 + 13, big_3
	dw $0C00 + 1 * 40 + 21, big_3

	cmap "*",$00
	cmap " ",$1B
	cmap "1",$1C,$1D,$1E,$1F,$3B,$3C,$3D,$3E,$3F
big_3
	db "1****2"
	db "**67**"
	db "   9**"
	db "   **5"
	db "   7**"
	db "**89**"
	db "3****4"

big_a
	db "1****2"
	db "**67**"
	db "**  **"
	db "******"
	db "**  **"
	db "**  **"
	db "**  **"

big_e
	db "1*****"
	db "**6 **"
	db "**    "
	db "****  "
	db "**    "
	db "**8 **"
	db "3*****"

big_l
	db "**    "
	db "**    "
	db "**    "
	db "**    "
	db "**    "
	db "**8 **"
	db "3*****"

big_r
	db "*****2"
	db "** 7**"
	db "** 9**"
	db "*****5"
	db "** 7**"
	db "**  **"
	db "**  **"

big_s
	db "1****2"
	db "**67**"
	db "**8   "
	db "3****2"
	db "   7**"
	db "**89**"
	db "3****4"

big_t
	db "******"
	db "  **  "
	db "  **  "
	db "  **  "
	db "  **  "
	db "  **  "
	db "  **  "

big_y
	db "**  **"
	db "**  **"
	db "**89**"
	db "3****4"
	db "  **  "
	db "  **  "
	db "  **  "
	cmap

big_3_empty
	db $5B,$9B,$7F,$7F,$9B,$5C
	db $7D,$7E,$3C,$3D,$9D,$9E
	db $1B,$1B,$1B,$3F,$9D,$9E
	;
	db $1B,$1B,$1B,$BB,$1B,$5F
	;
	db $1B,$1B,$1B,$3D,$9D,$9E
	db $7B,$7C,$3E,$3F,$9D,$9E
	db $5D,$9C,$7F,$7F,$9C,$5E

big_a_empty
	db $5B,$9B,$7F,$7F,$9B,$5C
	db $9D,$9E,$3C,$3D,$9D,$9E
	db $9D,$9E,$1B,$1B,$9D,$9E
	;
	db $9D,$BD,$7F,$7F,$BE,$9E
	;
	db $9D,$9E,$1B,$1B,$9D,$9E
	db $9D,$9E,$1B,$1B,$9D,$9E
	db $7D,$7E,$1B,$1B,$7D,$7E

big_e_empty
	db $5B,$9B,$7F,$7F,$DB,$7C
	db $9D,$9E,$3C,$1B,$7D,$7E
	db $9D,$9E,$1B,$1B,$1B,$1B
	;
	db $9D,$BD,$7F,$BF,$1B,$1B
	;
	db $9D,$9E,$1B,$1B,$1B,$1B
	db $9D,$9E,$3E,$1B,$7B,$7C
	db $5D,$9C,$7F,$7F,$DC,$7E

big_r_empty
	db $7B,$BC,$7F,$7F,$9B,$5C
	db $9D,$9E,$1B,$3D,$9D,$9E
	db $9D,$9E,$1B,$3F,$9D,$9E
	;
	db $9D,$BD,$7F,$7F,$1B,$5F
	;
	db $9D,$9E,$1B,$3D,$9D,$9E
	db $9D,$9E,$1B,$1B,$9D,$9E
	db $7D,$7E,$1B,$1B,$7D,$7E
	
	; -----------------------------------------------------
dycp_init
	ldx #(sine_end-sine_orig)
dil2	lda sine_orig,x
	sta sine_end,x
	dex
	bpl dil2
	;
	ldx #$00
dil1	lda sine_orig,x
	and #$07
	asl a
	asl a
	asl a
	asl a
	sta sine_bit,x
	lda sine_orig,x
	and #$F8
	sta m8+1
	sta src
	lda #$00
	sta src+1
	;
	asl src
	rol src+1
	asl src
	rol src+1
	;
	lda src
	clc
m8	adc #$00
	sta src
	;
	lda src+1
	adc #$00
	sta src+1
	;
	lda src					; top addr ($0D18)
	adc #$00
	sta sine_lo,x
	lda #$0C
	adc src+1
	sta sine_hi,x
	inx
	bne dil1
	rts

set_dycp_colors
	ldx #39
dpr_2	lda #$6B
	sta $0800 + 1 * 40,x
	lda #$62
	sta $0800 + 2 * 40,x
	sta $0800 + 3 * 40,x
	lda #$68
	sta $0800 + 4 * 40,x
	sta $0800 + 5 * 40,x
	lda #$69
	sta $0800 + 6 * 40,x
	sta $0800 + 7 * 40,x
	lda #$67
	sta $0800 + 8 * 40,x
	sta $0800 + 9 * 40,x
	dex
	bpl dpr_2
	;
	rts
	;
	; ---
	;
dycp_render
	lda scroll_x
	sec
dycp_speed
	sbc #$02
	bpl no_dycp_step
	;
	inc dycp_text_ptr+1
	;
	and #$07
	;
no_dycp_step
	sta scroll_x
	;
	jsr inc_dycp_sine
	;
	ldx #39
dycp_loop
	txa
	clc
sine1	adc sine_lo,x
	sta dycp_chr
sine2	lda sine_hi,x
	adc #$00
	sta dycp_chr+1
	;
	ldy #0
	lda #$80				; space char (in the dycp font)
	sta (dycp_chr),y
	ldy #120
	sta (dycp_chr),y
	;
dycp_text_ptr
	lda dycp_text,x
	bmi dycp_space
	;
	ldy #40
	clc
sine3	adc sine_bit,x
	sta (dycp_chr),y
	;
	ldy #80
	ora #$80
	sta (dycp_chr),y
	;
	dex
	bpl dycp_loop
	bmi dycp_loop_end
	;
dycp_space
	ldy #40
	lda #$80				; space char (in the dycp font)
	sta (dycp_chr),y 
	ldy #80
	sta (dycp_chr),y 
	;
	dex
	bpl dycp_loop 
	;
	; ---
	;
dycp_loop_end
	;
dycp_slowdown_call
	rts
	;
dycp_slowdown_index
	ldx #$00
	lda dycp_slowdown_values,x
	bmi ds_1
	sta dycp_speed+1
	inx
	stx dycp_slowdown_index+1
ds_1	rts

inc_dycp_sine
	lda sine1+1
	clc
	adc #$01
	cmp #(sine_end-sine_orig)
	bne *+4
	lda #$00
	sta sine1+1
	sta sine2+1
	sta sine3+1
	rts
	
enable_dycp_slowdown
	lda #$EA
	sta dycp_slowdown_call
	rts

enable_dycp_and_font_swap
	lda #$20     
	sta dycp_top_call
	sta dycp_call
	;
	lda #$20
	sta font_swap_call
	;
	lda #$58
	sta font_swap_rasterline+1
	;
	lda #$00
	sta $FF15				; switch background back to black (after big letters)
	;
	; ---
	;
	ldx #$68
dpr_1	lda #$80
	sta $0C00 + 0 * $68,x
	sta $0C00 + 1 * $68,x
	sta $0C00 + 2 * $68,x
	sta $0C00 + 3 * $68,x
	;
	dex
	bpl dpr_1
	;
	rts

disable_dycp
	lda #$2C
	sta dycp_top_call
	sta dycp_call
	rts

fade_dycp_colors
	lda dycp_color_1+1
	sec
	sbc #$10
	bpl *+4
	lda #$00
	sta dycp_color_1+1
	;
	lda dycp_color_2+1
	sec
	sbc #$10
	bpl *+4
	lda #$00
	sta dycp_color_2+1
	;
	lda dycp_color_3+1
	sec
	sbc #$10
	bpl *+4
	lda #$00
	sta dycp_color_3+1
	;
	lda dycp_color_4+1
	sec
	sbc #$10
	bpl *+4
	lda #$00
	sta dycp_color_4+1
	;
	lda dycp_color_5+1
	sec
	sbc #$10
	bpl *+4
	lda #$00
	sta dycp_color_5+1
	;
	ldx #12
fd_1
dycp_color_1
	lda #$6B
	sta $0800 + 1 * 40 + 13,x
dycp_color_2
	lda #$62
	sta $0800 + 2 * 40 + 13,x
	sta $0800 + 3 * 40 + 13,x
dycp_color_3
	lda #$68
	sta $0800 + 4 * 40 + 13,x
	sta $0800 + 5 * 40 + 13,x
dycp_color_4
	lda #$69
	sta $0800 + 6 * 40 + 13,x
	sta $0800 + 7 * 40 + 13,x
dycp_color_5
	lda #$67
	sta $0800 + 8 * 40 + 13,x
	sta $0800 + 9 * 40 + 13,x
	dex
	bpl fd_1
	;
	; ---
	;
curtain_wipe
	ldy #$01
	jsr curtain_wipe_column
	lda #39
	sec
	sbc curtain_wipe+1
	inc curtain_wipe+1
	tay
curtain_wipe_column
	lda #($0800 + 11 * 40) & 255
	sta dst_col
	lda #($0800 + 11 * 40) >> 8
	sta dst_col+1
	;
	ldx #13
cwc_1	lda #$00
	sta (dst_col),y
	;
	lda dst_col
	clc
	adc #40
	sta dst_col
	bcc *+4
	inc dst_col+1
	dex
	bpl cwc_1
	rts

change_u_questionmark
	; $7C,$C6,$06,$0C,$18,$30,$00,$30
	lda #$7C
	sta dycp_font+14*8 + 0*128 + 0
	sta dycp_font+14*8 + 1*128 + 1
	sta dycp_font+14*8 + 2*128 + 2
	sta dycp_font+14*8 + 3*128 + 3
	sta dycp_font+14*8 + 4*128 + 4
	sta dycp_font+14*8 + 5*128 + 5
	sta dycp_font+14*8 + 6*128 + 6
	sta dycp_font+14*8 + 7*128 + 7
	;
	lda #$06
	sta dycp_font+14*8 + 0*128 + 2
	sta dycp_font+14*8 + 1*128 + 3
	sta dycp_font+14*8 + 2*128 + 4
	sta dycp_font+14*8 + 3*128 + 5
	sta dycp_font+14*8 + 4*128 + 6
	sta dycp_font+14*8 + 5*128 + 7
	sta dycp_font+14*8 + 14*128 + 0
	sta dycp_font+14*8 + 15*128 + 1
	;
	lda #$0C
	sta dycp_font+14*8 + 0*128 + 3
	sta dycp_font+14*8 + 1*128 + 4
	sta dycp_font+14*8 + 2*128 + 5
	sta dycp_font+14*8 + 3*128 + 6
	sta dycp_font+14*8 + 4*128 + 7
	sta dycp_font+14*8 + 13*128 + 0
	sta dycp_font+14*8 + 14*128 + 1
	sta dycp_font+14*8 + 15*128 + 2
	;
	lda #$18
	sta dycp_font+14*8 + 0*128 + 4
	sta dycp_font+14*8 + 1*128 + 5
	sta dycp_font+14*8 + 2*128 + 6
	sta dycp_font+14*8 + 3*128 + 7
	sta dycp_font+14*8 + 12*128 + 0
	sta dycp_font+14*8 + 13*128 + 1
	sta dycp_font+14*8 + 14*128 + 2
	sta dycp_font+14*8 + 15*128 + 3
	;
	lda #$30
	sta dycp_font+14*8 + 0*128 + 5
	sta dycp_font+14*8 + 1*128 + 6
	sta dycp_font+14*8 + 2*128 + 7
	sta dycp_font+14*8 + 11*128 + 0
	sta dycp_font+14*8 + 12*128 + 1
	sta dycp_font+14*8 + 13*128 + 2
	sta dycp_font+14*8 + 14*128 + 3
	sta dycp_font+14*8 + 15*128 + 4
	;
	lda #$00
	sta dycp_font+14*8 + 0*128 + 6
	sta dycp_font+14*8 + 1*128 + 7
	sta dycp_font+14*8 + 10*128 + 0
	sta dycp_font+14*8 + 11*128 + 1
	sta dycp_font+14*8 + 12*128 + 2
	sta dycp_font+14*8 + 13*128 + 3
	sta dycp_font+14*8 + 14*128 + 4
	sta dycp_font+14*8 + 15*128 + 5
	;
	lda #$30
	sta dycp_font+14*8 + 0*128 + 7
	sta dycp_font+14*8 + 9*128 + 0
	sta dycp_font+14*8 + 10*128 + 1
	sta dycp_font+14*8 + 11*128 + 2
	sta dycp_font+14*8 + 12*128 + 3
	sta dycp_font+14*8 + 13*128 + 4
	sta dycp_font+14*8 + 14*128 + 5
	sta dycp_font+14*8 + 15*128 + 6
	rts

legion_logo_on
	lda #$FE
	cmp $FF1C
	bne *-3
	;
	lda #$58
	cmp $FF1D
	bcs *-3
	;
	lda #legion_logo_charset >> 8
	sta $FF13
	;
	lda $FF07
	and #$40
legion_logo_shake_value
	ora #$9C
	sta $FF07
	;
	lda #$4D
	sta $FF16
	lda #$2D
	sta $FF17
	;
	rts

legion_logo_shake
	ldx #$00
	lda legion_logo_shake_values,x
	sta legion_logo_shake_value+1
	inx
	cpx #$07
	bne *+4
	ldx #$00
	stx legion_logo_shake+1
	rts

legion_logo_shake_values
	db $98,$9B,$9E,$9F,$9E,$9D,$9C

legion_logo_hide
	ldx #$00
llh_1	lda #$00
	sta legion_logo_charset,x
	sta legion_logo_charset+$B0,x
	txa
	clc
	adc #$08
	tax
	cpx #$B0
	bcc llh_1
	inc legion_logo_hide+1
	rts
	
legion_color
	lda #$92
	cmp $FF1D
	bcs *-3
	;
	lda #$49
	sta $FF16
	lda #$29
	sta $FF17
	rts

disable_legion_logo
	lda #$2C
	db $2C
enable_legion_logo
	lda #$20
	sta legion_logo_on_call
	sta legion_color_call
	;
	rts

draw_legion_colors
	ldy #33
dlc_1	lda #$06+8				; once unrolled (to fit on NTSC)
	sta $0800+13*40+3,y
	sta $0800+14*40+3,y
	sta $0800+15*40+3,y
	lda #$66+8
	sta $0800+16*40+3,y
	sta $0800+17*40+3,y
	lda #$07+8
	sta $0800+18*40+3,y
	sta $0800+19*40+3,y
	sta $0800+20*40+3,y
	lda #$67+8
	sta $0800+21*40+3,y
	sta $0800+22*40+3,y
	dey
	sta $0800+21*40+3,y
	sta $0800+22*40+3,y
	lda #$06+8
	sta $0800+13*40+3,y
	sta $0800+14*40+3,y
	sta $0800+15*40+3,y
	lda #$66+8
	sta $0800+16*40+3,y
	sta $0800+17*40+3,y
	lda #$07+8
	sta $0800+18*40+3,y
	sta $0800+19*40+3,y
	sta $0800+20*40+3,y
	dey
	bpl dlc_1
	rts

draw_legion_logo_1
	ldy #33
dl_1	lda legion_logo_charmap+0*40+3,y
	sta $0C00+13*40+3,y
	lda legion_logo_charmap+1*40+3,y
	sta $0C00+14*40+3,y
	lda legion_logo_charmap+2*40+3,y
	sta $0C00+15*40+3,y
	lda legion_logo_charmap+3*40+3,y
	sta $0C00+16*40+3,y
	lda legion_logo_charmap+4*40+3,y
	sta $0C00+17*40+3,y
	dey
	bpl dl_1
	rts

draw_legion_logo_2
	ldy #33
dl_2	lda legion_logo_charmap+5*40+3,y
	sta $0C00+18*40+3,y
	lda legion_logo_charmap+6*40+3,y
	sta $0C00+19*40+3,y
	lda legion_logo_charmap+7*40+3,y
	sta $0C00+20*40+3,y
	lda legion_logo_charmap+8*40+3,y
	sta $0C00+21*40+3,y
	lda legion_logo_charmap+9*40+3,y
	sta $0C00+22*40+3,y
	dey
	bpl dl_2
	rts

erase_legion_colors_1
	ldy #40*5
	lda #$00
elc_1	sta $0800+13*40-1,y
	dey
	bne elc_1
	rts

erase_legion_colors_2
	ldy #40*5
	lda #$00
elc_2	sta $0800+13*40 + 40*5-1,y
	dey
	bne elc_2
	rts

erase_legion_logo_1
	ldy #40*5
	lda #$1B
el_1	sta $0C00+13*40-1,y
	dey
	bne el_1
	rts

erase_legion_logo_2
	ldy #40*5
	lda #$1B
el_2	sta $0C00+13*40 + 40*5-1,y
	dey
	bne el_2
	rts
	
copy_title_columns_setup
	lda #title_charset >> 8
	sta top_font+1
	;
	ldy #(18 / 2)				; width: 18 chars
	sty title_column_1
	dey
	sty title_column_2
	rts
	;
copy_title_columns
	dec title_column_1
	inc title_column_2
	;
	ldy title_column_1
	jsr copy_title_column
	;
	ldy title_column_2
	;
copy_title_column
	lda #($0C00 + 6 * 40 + (40-18)/2) & 255
	sta dst_col
	sta dst_chr
	lda #($0C00 + 6 * 40 + (40-18)/2) >> 8
	sta dst_chr+1
	and #$FB
	sta dst_col+1
	;
	lda #title_charmap & 255
	sta src
	lda #title_charmap >> 8
	sta src+1
	;
	ldx #12 - 1				; height: 12 chars
ctc2	lda (src),y
	sta (dst_chr),y
	lda #$71
	sta (dst_col),y
	;
	lda dst_col
	clc
	adc #40
	sta dst_col
	sta dst_chr
	bcc *+6
	inc dst_col+1
	inc dst_chr+1
	;
	lda src
	clc
	adc #18
	sta src
	bcc *+4
	inc src+1
	;
	dex
	bpl ctc2
	;
	rts

volume_down
	ldx #$05
	;
vd_4	lda #kick_c_sample & 255
	sta src
	lda #kick_c_sample >> 8
	sta src+1
	;
vd_3	ldy #$00 
vd_2	lda (src),y					; turn down samples (in 6 steps)
	beq vd_1
	sec
	sbc #$01
	sta (src),y
vd_1	iny
	bne vd_2
	;
	inc src+1
	lda src+1
	cmp #(kick_c_sample + (sample_data_end - kick_c_sample)/2) >> 8
	bne vd_3a
	;
	jsr fade_title
	;
vd_3a	cmp #sample_data_end >> 8
	bne vd_3
	;
	jsr fade_title
	;
	txa
	and #$01					; on every 2nd frame
	beq vd_5
	;
	dec $011C ; no_digi_volume_add+1		; must use relocated address
	;
	ldy #13
vd_7	lda vol_default,y				; turn down volume envelope (in 3 steps)
	beq vd_6
	sec
	sbc #$01
	sta vol_default,y
vd_6	dey
	bpl vd_7
	;
vd_5	dex
	bpl vd_4
	;
	rts

fade_title
	ldy #17
	lda $0800 + 6 * 40 + (40-18)/2
	sec
	sbc #$10
	bpl fade_1
	lda #$00
fade_1	sta $0800 + 6 * 40 + (40-18)/2,y
	sta $0800 + 7 * 40 + (40-18)/2,y
	sta $0800 + 8 * 40 + (40-18)/2,y
	sta $0800 + 9 * 40 + (40-18)/2,y
	sta $0800 + 10 * 40 + (40-18)/2,y
	sta $0800 + 11 * 40 + (40-18)/2,y
	sta $0800 + 12 * 40 + (40-18)/2,y
	sta $0800 + 13 * 40 + (40-18)/2,y
	sta $0800 + 14 * 40 + (40-18)/2,y
	sta $0800 + 15 * 40 + (40-18)/2,y
	sta $0800 + 16 * 40 + (40-18)/2,y
	sta $0800 + 17 * 40 + (40-18)/2,y
	dey
	bpl fade_1
	rts

	include "music\!playerv.asm"
	include "music\!player.asm"
	include "music\music.asm"

	align $0800
	include "mb_logo.asm"
	
	align $0800
	include "title.asm"

	align $0800	
fonts
	include "fonts.asm"
	
	align $0800
dycp_font
	include "dycp_font.asm"

	include "legion_logo.asm"

	align 256
sine_orig
;64,31.5,0,48
	db $00,$00,$01,$01,$02,$04,$05,$07,$09,$0C,$0E,$11,$13,$16,$19,$1C
	db $1F,$23,$26,$29,$2C,$2E,$31,$33,$36,$38,$3A,$3B,$3D,$3E,$3E,$3F
	db $3F,$3F,$3E,$3E,$3D,$3B,$3A,$38,$36,$33,$31,$2E,$2C,$29,$26,$23
	db $20,$1C,$19,$16,$13,$11,$0E,$0C,$09,$07,$05,$04,$02,$01,$01,$00
;40,31.5,0,30	
	db $00,$00,$02,$03,$06,$09,$0D,$11,$16,$1B,$1F,$24,$29,$2E,$32,$36
	db $39,$3C,$3D,$3F,$3F,$3F,$3D,$3C,$39,$36,$32,$2E,$29,$24,$20,$1B
	db $16,$11,$0D,$09,$06,$03,$02,$00
sine_end

	align 256
dycp_text
	cmap "A", 0
	cmap "D", 1
	cmap "E", 2
	cmap "F", 3
	cmap "G", 4
	cmap "H", 5
	cmap "I", 6
	cmap "L", 7
	cmap "M", 8
	cmap "N", 9
	cmap "O", 10
	cmap "R", 11
	cmap "S", 12
	cmap "T", 13
	cmap "U", 14
	cmap "W", 15
	cmap " ", $FF
	db "          "
	db "          "
	db "          "
	db "         "
	db "IN THE FUTURE LOD RETURNS WITH A REMASTERED RELEASE OF THE GAME"
	db "         "
	db "         "
	db "WHAT IS NEWU"
	db "          "
	db "          "
	cmap

dycp_slowdown_values
	db 1,2,2,2,2,2
	db 1,2,2,2,2,2
	db 1,2,2,2,2
	db 1,2,2,2,2
	db 1,2,2,2
	db 1,2,2,2
	db 1,2,2
	db 1,2,2
	;
	db 1,2,1,2
	db 1,2,1,2
	db 1,2,1,2
	db 1,2,1,2
	;
	db 1,1,2
	db 1,1,2
	db 1,1,1,2
	db 1,1,1,2
	db 1,1,1,1,2
	db 1,1,1,1,2
	db 1,1,1,1,1,2
	db 1,1,1,1,1,2
	;
	db 1,1,1,1
	db 1,1,1,1
	db 1,1,1,1
	db 1,1,1,1
	;
	db 0,1,1,1,1,1
	db 0,1,1,1,1,1
	db 0,1,1,1,1
	db 0,1,1,1,1
	db 0,1,1,1
	db 0,1,1,1
	db 0,1,1
	db 0,1,1
	;
	db 0,1,0,1
	db 0,1,0,1
	db 0,1,0,1
	db 0,1,0,1
	;
	db 0,0,1
	db 0
	db $FF

	include "timeline.asm"
	
timeline;_orig
	dw 4*7, nothing
	dw 1, write_green_line_setup
	dw 8*7-1, nothing
	dw 1, write_green_line
	dw 8*7-1, nothing
	dw 1, copy_mb_columns_setup
	dw 15, copy_mb_columns
	dw 8*7-16, nothing
	dw 1, write_green_line
	dw 8*7-1, nothing
	dw 4, write_green_line
	dw 8*7-4-1, nothing
	dw 1, enable_scroll
	dw 8*7, nothing
	;
	dw 1, enable_logo_flash
	dw 9*8*7-2, nothing
	dw 1, disable_scroll
	;
	dw 1, clear_10_columns_setup
	dw 1, speedup_logo_flash
	dw 1*7-2, nothing
	;
	dw 1, clear_10_columns
	dw 1*7-1, nothing
	;
	dw 1, clear_10_columns
	dw 1*7-1, nothing
	;
	dw 1, clear_10_columns
	dw 1*7-(1+1+1+3), nothing
	dw 1, disable_logo_and_font_swap
	dw 1, fill_with_inverse_setup
	dw 3, fill_with_inverse
	;
	; ---
	;
timeline_1 ; for testing
	dw 1, write_big_letter_setup
	dw 3*7-1, nothing
	;
	dw 1, write_2_big_letters
	dw 1*7-1, nothing
	dw 1, enable_flash_write_big_letter
	dw 2*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 5*7-1, nothing
	;
	dw 1, write_2_big_letters
	dw 1*7-1, nothing
	dw 1, write_2_big_letters
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 2*7-1, nothing
	;
	dw 1, write_big_letter
	dw 3*7-1, nothing
	;
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 2*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 5*7-1, nothing
	;    
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	;
	; last bar: 3,1,2, 1,2,3, 1,1,2
	dw 1, write_big_letter
	dw 3*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 2*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 2*7-1, nothing
	dw 1, write_big_letter
	dw 3*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 1*7-1, nothing
	dw 1, write_big_letter
	dw 2*7-1, nothing
	;
	; remove
	dw 1, erase_big_letter_setup
	dw 1, erase_big_letter
	dw 3*7-2, nothing
	dw 1, erase_2_big_letters
	dw 1*7-1, nothing
	dw 1, erase_3_big_letters
	dw 2*7-1, nothing
	dw 1, erase_2_big_letters
	dw 1*7-1, nothing
	dw 1, erase_3_big_letters
	dw 1, disable_big_letter_flash
	dw 9*7-4, nothing
	;
	; ---
	;
timeline_2
	dw 1, enable_dycp_and_font_swap
	dw 1, set_dycp_colors
	dw 4*7-3, nothing
	dw 1, enable_legion_logo
	dw 1, draw_legion_logo_1
	dw 1, draw_legion_logo_2
	dw 1, draw_legion_colors
	dw 8*7-1, nothing
	;
	dw 7, legion_logo_shake
	dw 8*7-7, nothing
	;
	dw 7, legion_logo_shake
	dw 8*7-7, nothing
	;
	dw 7, legion_logo_shake
	dw 8*7-7, nothing
	;
	dw 7, legion_logo_shake
	dw 8*7-7, nothing
	;
	dw 7, legion_logo_shake
	dw 14, nothing
	dw 1, enable_dycp_slowdown
	dw 34, nothing
	;
	dw 7, legion_logo_shake
	dw 1, change_u_questionmark
	dw 48, nothing
	;
	dw 8, legion_logo_hide
	dw 1, erase_legion_colors_1
	dw 1, erase_legion_colors_2
	dw 1, erase_legion_logo_1
	dw 1, erase_legion_logo_2
	dw 1, disable_legion_logo
	dw 2*7-10, nothing
	dw 11, nothing
	;
timeline_3
	dw 1, write_green_line			; chorus start
	dw 4*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, green_line_copy_1
	dw 1*7-1, nothing
	dw 1, green_copy_right
	dw 2*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, green_line_copy_3
	dw 1*7-1, nothing
	dw 1, green_copy_right
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 5*7-1, nothing
	;
	dw 1, write_green_line_gray		; "improved music"
	dw 1, gray_color_highlight
	dw 1*7-2, nothing
	dw 1, gray_color_highlight_2
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_2
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_2
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_2
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_2
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_2_4
	dw 1, gray_color_highlight
	dw 2*7-2, nothing
	dw 1, gray_color_highlight_4
	dw 1, gray_color_highlight
	dw 1*7-2, nothing
	dw 1, gray_color_highlight_4
	dw 1, gray_color_highlight
	dw 1*7-2, nothing
	dw 1, gray_color_highlight_4
	dw 1, gray_color_highlight
	dw 1*7-2, nothing
	;
	dw 1, write_green_line
	dw 4*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, green_line_copy_5
	dw 1*7-1, nothing
	dw 1, green_copy_right
	dw 2*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, green_line_copy_7
	dw 1*7-1, nothing
	dw 1, green_copy_right
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 5*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, color_green_1
	dw 1*7-1, nothing
	dw 1, color_green_2
	dw 1*7-1, nothing
	dw 1, color_green_3
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, color_green_1
	dw 1*7-1, nothing
	dw 1, color_green_2
	dw 1*7-1, nothing
	dw 1, color_green_3
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, color_green_1
	dw 1*7-1, nothing
	dw 1, color_green_2
	dw 1*7-1, nothing
	dw 1, color_green_3
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 1*7-1, nothing
	dw 1, color_green_1
	dw 1*7-1, nothing
	dw 1, color_green_2
	dw 1*7-1, nothing
	dw 1, color_green_3
	dw 1*7-1, nothing
	;
	dw 1, write_green_line
	dw 4*7-1, nothing
	;
	dw 4*8*7-32, nothing
	;
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	dw 2, curtain_wipe
	dw 1, fade_dycp_colors
	;
	dw 1, disable_dycp
	dw 1, disable_logo_and_font_swap
	dw 1, clear_10_columns_setup
	dw 1, clear_10_columns
	dw 1, clear_10_columns
	dw 1, clear_10_columns
	;
timeline_x
	dw 1, copy_title_columns_setup
	dw 9, copy_title_columns
	;
	dw 4*8*7, nothing
	;
	dw 1, volume_down
	dw 1, quit
	;
timeline_stopped
	dw $FFFF, nothing
;eof