;
; LOD Player Version 2
;
F1LO	= $FF0E	; square only
F1HI	= $FF12
F2LO	= $FF0F	; square + noise
F2HI	= $FF10
OFF	= $3F
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
SET_ARP		= $FD
SETINS		= $F0
SETLEN		= $40

; Constants
base_note = -9 ; shift
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----

RELOCATED_ZP = 2
digi_addr = iq0 - irq_digi + RELOCATED_ZP

digi_order	= $90		; digi player variables
digi_pattern	= digi_order + 2
sample_length	= digi_order + 4 ; byte for sample length
note_length	= digi_order + 5 ; byte for speed 'digi_step'
digi_step	= digi_order + 6 ; byte flag to start playing new sample

astack = digi_order-1
ystack = digi_order-2

	;
	; #####################
	;
irq_digi
	pha
	lda $FF09
	sta $FF09
	and #$02
	beq iq0
	;
	;dec $FF19
	;dec $FF19
	txa
	pha
	tya
	pha
	jsr PLAYER
	pla
	tay
	pla
	tax
	;
	lda $FF0B
	eor #($CC ^ $30)
	sta $FF0B
	;inc $FF19
	;inc $FF19
	;
	pla
	rti
	;       
iq0	lda $FF11		; +05 - (4) self-mod
	clc
	;
	;lda VOLUME		; test 1: TED only
	;clc
	;adc #$03
	;
	ora #$B0		; test 2: digi only
	;
	sta $FF11		; (4) set Volume: play digi
	;
	inc digi_addr+1		; (5)
	bne id_noinc		; (3) if taken
	inc digi_addr+2		;
	;
	dec sample_length
	bne id_noinc
	;
	inc $FFFF		; go to irq_null from now on
	;
id_noinc
	pla
	rti			; (6)
irq_digi_end	
	;
	; #####################
	;
irq_null
	pha
	lda $FF09
	sta $FF09
	and #$02
	beq iq1
	;
	;dec $FF19
	;dec $FF19
	txa
	pha
	tya
	pha
	jsr PLAYER
	pla
	tay
	pla
	tax
	;inc $FF19
	;inc $FF19
	;
	lda VOLUME
	clc
no_digi_volume_add
	adc #$03
	lda #$00
	sta $FF11
	;
	lda $FF0B
	eor #($CC ^ $30)
	sta $FF0B
	;
iq1	pla
	rti
irq_null_end
          
PLAYER_INIT
	ldx #$FF
	stx VOLTAB_CNT
	inx       
	stx NOTE1
	stx NOTE2
	stx ARP_CNT
	stx VOLUME
	jsr res
	inx
	stx NOTELEN1
	stx NOTELEN2
	jsr res
	;
	; --- DIGI INIT
	;
	ldx #irq_null_end - irq_null
irqc1	lda irq_null,x				; copy irq to $01xx area
	sta $0100 + RELOCATED_ZP,x
	dex
	bpl irqc1
	;
	ldx #irq_digi_end - irq_digi
irqc2	lda irq_digi,x
	sta RELOCATED_ZP,x
	dex
	bpl irqc2
	;
	lda #$02
	sta $FFFE
	ldx #$00
	stx $FFFF
	lda #$AA
	sta $FF0A
	;
	lda $FF09
	sta $FF09
	;
	; ---
	;
	ldy #$00
	sty digi_step
	ldx #$80				; digi speed: both for NTSC and PAL
	stx $FF00				; set digi speed
	sty $FF01
	;  
	; ***
	;          
	lda #Orders & 255
	ldx #Orders >> 8
	sta digi_order
	stx digi_order + 1
	;                
	lda (digi_order),y			; preload first pattern pointer
	sta digi_pattern
	;
	inc digi_order
	;
	lda (digi_order),y
	sta digi_pattern + 1
	;
	inc digi_order
	;   
	lda (digi_pattern),y			; first byte: sample address high (or zero for repeat)
	sta digi_addr+2
	sty digi_addr+1				; low byte always zero
	;
	inc digi_pattern
	;       
	lda (digi_pattern),y			; 2nd byte: total sample length
	sta sample_length
	;
	inc digi_pattern
	;
	lda (digi_pattern),y			; 3rd byte: note length
	sta note_length
	;
	inc digi_pattern
	;
	rts
	
;player_irq
;	sta SAVE_A
;	stx SAVE_X
;	sty SAVE_Y
;	;
;	dec $FF19
;	;
;	lda $FF09
;	sta $FF09
;	tax
;	and #$08
;	beq no_timer
;	;
;digi_index
;	lda digi
;	clc
;	adc VOLUME
;volume_down_1
;	cmp #$38
;	bcc *+4
;volume_down_2
;	lda #$38
;	sta $FF11
;	;
;	;inc digi_index+1
;	;bne *+5
;	;inc digi_index+2
;	;
;	lda digi_index+1
;	cmp #digi_end & 255
;	bne no_timer
;	lda digi_index+2
;	cmp #digi_end >> 8
;	bne no_timer
;	;
;	lda #digi & 255
;	sta digi_index+1
;	lda #digi >> 8
;	sta digi_index+2
;	;
;no_timer
;	txa
;	and #$02
;	beq no_raster
;	;
;	jsr PLAYER
;	;
;	lda $FF0B
;	eor #($CC ^ $30)
;	sta $FF0B
;	;
;no_raster
;	inc $FF19
;	;
;	lda SAVE_A
;	ldx SAVE_X
;	ldy SAVE_Y
;	rti

res	
	lda ch_ptrs_lo,x
	sta PCH1_LO,x
	lda ch_ptrs_hi,x
	sta PCH1_HI,x
	;
advance	
	lda PCH1_LO,x
	sta PCH_TEMP
	lda PCH1_HI,x
	sta PCH_TEMP+1
	;
	ldy #$01
	lda (PCH_TEMP),y	; HI byte
	beq res			; when high byte is zero, it's the end of the Channel
	sta CH1_HI,x
	dey
	lda (PCH_TEMP),y	; LO byte
	sta CH1_LO,x
	;
	lda PCH1_LO,x
	clc
	adc #$02
	sta PCH1_LO,x
	bcc *+4
	inc PCH1_HI,x
	rts
	
	;
	;##################
	;

PLAYER      
	;rts
;	lda $FF19
;	sta *+17
;	lda #$67
;	sta $FF19
;	eor #$32^$67
;	sta *-6
;	jsr PLAYER_
;	lda #$00
;	sta $FF19
;	rts
;PLAYER_
	ldx #$01
channel_loop
	inc NOTE1,x
	;
	lda NOTE1,x
	cmp NOTELEN1,x
	beq next_note
	jmp channel_loop_end
	;
next_note 
	lda CH1_LO,x
	sta CH_TEMP
	lda CH1_HI,x
	sta CH_TEMP+1
	;
	ldy #$00
	sty NOTE1,x		; reset note counter
	;   
	lda (CH_TEMP),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	bne pl_10
	;
	jsr advance
	bne next_note		; should never be zero
	;
pl_10	
	cmp #SET_VOLTAB
	bne pl_12
	;
	sta VOLTAB_CNT
	;
	lda (CH_TEMP),y		; get lo byte only!
	iny
	sta VOL_TAB+1
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_12	
	cmp #SET_ARP		; instrument change?
	bne pl_13
	;
	lda #12
	sta arpeggio_length+1
	;
	lda (CH_TEMP),y		; get arpeggio byte
	lsr a
	lsr a
	lsr a
	lsr a
	sta arpeggio_data+1
	;
	lda (CH_TEMP),y		; get same byte again 
	and #$0F
	sta arpeggio_data+2
	bne pl_12a
	;
	lda #8
	sta arpeggio_length+1
	;
pl_12a	iny
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_13	cmp #SETINS		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1,x   	; store instrument type
	;
	lda (CH_TEMP),y		; get byte
	iny
	;
pl_01	cmp #SETLEN		; set note length?
	bcc pl_02
	;
	sbc #$40		; we know carry is always set
	sta NOTELEN1,x
	;
	lda (CH_TEMP),y
	iny
	;
pl_02	; - store note!
	;
	sta TONE1,x
	;
;	cpx #$01		; for channel 1 (x=0) only
;	beq pl_00
;	cmp #OFF
;	beq pl_00
;	lda #$00		; visual debug
;	inc $FF19
;	clc
;	adc #$01
;	bpl *-6
	;
	;lda #$FF		; reset the voltab counter on each note
	;sta VOLTAB_CNT 
	;bne pl_0a
	;
pl_00	lda #$FF		; for channel 2 only
	sta ARP_CNT		; reset ARP_CNT on each note	
	;
	;
	; --- advance pointer
	;
pl_0a	tya
	clc
	adc CH1_LO,x
	sta CH1_LO,x
	bcc noi_1
	inc CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	dex
	bmi pl_50
	jmp channel_loop
	;    
pl_50	
	dec note_length		; for digi: DEC = digi is playing, LDA = stop digi
	bne PLAYER_SOUND
	;
	; ---
	;
read_nextbyte
	ldy #$00
	sty digi_step
	sty $FFFF		; irq_digi (relocated address!) back to normal digi playing
	;
	lda (digi_pattern),y	; first byte: sample digi_address high (or zero for repeat)
	beq digi_patternEnd
	;
	sta digi_addr+2
	sty digi_addr+1
	;
	inc digi_pattern
	;       
	lda (digi_pattern),y	; 2nd byte: total sample length
	sta sample_length
	;
	inc digi_pattern
	;
	lda (digi_pattern),y	; 3rd byte: note length
	sta note_length
	;
	inc digi_pattern
;	BNE noinc_1
;	INC digi_pattern+1
;noinc_1
	;
	; ----------
	;
	jmp PLAYER_SOUND
	;
restart_order
	lda #Orders & 255
	sta digi_order
	;
	lda #Orders >> 8
	sta digi_order + 1
	;                
digi_patternEnd
	lda (digi_order),y
	sta digi_pattern
	;
	inc digi_order
	;
	lda (digi_order),y
	sta digi_pattern + 1
	;
	beq restart_order
	;
	inc digi_order
	;
	jmp read_nextbyte
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20
	sta NOISE
	;
	ldx #$00		; channel 1
	jsr sound
	sta F1LO
	sty F1HI_store+1
	lda F1HI
	and #$FC
F1HI_store
	ora #$00
	sta F1HI
	;
	ldx #$01		; channel 2
	jsr sound
	;
;	cmp #$FE
;	bne use_ch2
;	;
;	ldx #$02		; channel 3
;	jsr sound
;	;
;use_ch2	
	sta F2LO
	sty F2HI
	;
	; ---
	;
	ldy VOLTAB_CNT
	iny
res_v	
VOL_TAB
	lda vol_default,y
	bpl noi_v		; check for >$F0
	and #$0F
	tay
	jmp res_v
noi_v	sty VOLTAB_CNT
	;clc
	;adc VOLUME
	;tay
	ora NOISE
	;
	;ldy F1LO
	;cpy #$FE
	;bne setvol		; not silent
	;ldy F2LO
	;cpy #$FE
	;beq sil			; silent: skip setting $FF11 to avoid clicks
	;
;setvol	sta $FF11		; self-mod
	ora #$10
	sta VOLUME
	;
sil	rts     
	;
inst_table
	dw normal, normal, normal, hihat, arpeggio, vibrato1, vibrato2, vibrato3
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	
	;
	; ---
	;
normal	lda TONE1,x		; normal note
lookup	tax
	lda freqs_lo,x
	ldy freqs_hi,x
	rts
	;
	; ---
	;
;blipp	lda TONE1,x
;	ldy NOTE1,x
;	cpy #$03
;	bcs blipp_off
;	cpy #$02
;	bcc lookup
;	clc
;	adc #$0C
;	bne lookup
;	
;blipp_off
;	lda #OFF
;	bne lookup
;	;
;	; ---
;	;
arpeggio
	lda ARP_CNT		; load current arp counter
	clc
	adc #$01
arpeggio_length
	cmp #12			; reset at 12 (4 ticks per note)
	bne *+4
	lda #$00
	sta ARP_CNT
	tay
	lda div12,y
	tay
	lda arpeggio_data,y	; for channel 2 (self-mod)
	clc
	adc TONE1,x
	bne lookup
	;
	; ---
	;
vibrato3
	lda NOTE1,x
	and #$0F
	tay
	lda vibrato3_data,y
	bmi vib_sub1
	bpl vib_add
	
vibrato2
	lda NOTE1,x
	and #$0F
	tay
	lda vibrato2_data,y
	bmi vib_sub1
	bpl vib_add
	
vibrato1
	lda NOTE1,x
	and #$0F
	tay
	lda vibrato1_data,y
	bmi vib_sub1
	;
vib_add
	sta vib2+1
	;
	lda TONE1,x
	tax
	ldy freqs_hi,x
	lda freqs_lo,x
	clc
vib2	adc #$01
	bcc *+3
	iny
	rts
	;
vib_sub1
	and #$7F
	;      
	sta vib4+1
	;
	lda TONE1,x
	tax
	ldy freqs_hi,x
	lda freqs_lo,x
	sec
vib4	sbc #$01
	bcs *+3
	dey
	rts
	;
	; ---
	;
hihat
	lda #$40
	sta NOISE
	lda NOTE1,x
	tax
	lda hihat_freq,x
	ldy #$03
	rts
	;
	; ---
	;
;snare	
;	lda NOTE1,x
;	asl a
;	tax
;	lda snare_data+1,x	; keep noise bit
;	and #$60
;	sta NOISE
;	lda snare_data+1,x	; absolute freq
;	and #$03
;	tay
;	lda snare_data,x
;	rts
;	;
;	; ---
;	;
;bassdrum
;	lda NOTE1,x
;	asl a
;	tax
;	lda bass_freq,x
;	ldy bass_freq+1,x
;	rts

freqs_lo
	db $10,$49,$7E,$B1, $E0,$0D,$37,$5F
	db $85,$A9,$CA,$EA, $08,$24,$3F,$58
	db $70,$86,$9C,$B0, $C3,$D4,$E5,$F5
	db $04,$12,$20,$2C, $38,$43,$4E,$58
	
	db $61,$6A,$73,$7B, $82,$89,$90,$96
	db $9C,$A2,$A7,$AC, $B1,$B5,$B9,$BD
	db $C1,$C5,$C8,$CB, $CE,$D1,$D3,$D6
	db $D8,$DB,$DD,$DF, $E1,$FE,$FE,$FE

freqs_hi
	db $00,$00,$00,$00, $00,$01,$01,$01
	db $01,$01,$01,$01, $02,$02,$02,$02
	db $02,$02,$02,$02, $02,$02,$02,$02
	db $03,$03,$03,$03, $03,$03,$03,$03
	
	db $03,$03,$03,$03, $03,$03,$03,$03
	db $03,$03,$03,$03, $03,$03,$03,$03
	db $03,$03,$03,$03, $03,$03,$03,$03
	db $03,$03,$03,$03, $03,$03,$03,$03

div12
	db 0,0,0,0,1,1,1,1,2,2,2,2

arpeggio_data
	db 0,0,0

vibrato1_data
	db $00,$01,$01,$02,$02,$01,$01,$00
	db $00,$81,$81,$82,$82,$81,$81,$00
	
vibrato2_data
	db $00,$01,$02,$03,$03,$03,$02,$01
	db $00,$81,$82,$83,$83,$83,$82,$81
	
vibrato3_data
	db $00,$02,$04,$05,$05,$05,$04,$02
	db $00,$82,$84,$85,$85,$85,$84,$82
;[eof]