	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

; keyboard
keyb_ptr		= $C4		; 16 bit
keyb_lastkey		= $C6
keyb_repeatcnt		= $C7
keyb_shift		= $C8
keyb_repeat_init	= 20		; constant
keyb_repeat		= 4		; constant

col			= $D0
chr			= $D2
src			= $D4
src2			= $D6
pg_num			= $D8
bitmap_src		= $DA
bitmap_dst		= $DE

screen_src		= $E0
screen_dst		= $E2

title_colmap 		= title_screen + $2000
title_target 		= $C000

FOLDER_COLOR		= $68
PAPER_COLOR		= $71

start
	sei
	sta $ff3f
	jmp skip_compressed_data
decompress
	include "../iten_comp1_hex.asm"
	include "../iten_comp2_hex.asm"
	db 0,0,0

skip_compressed_data
	lda $02
	beq dont_skip_title
	;
	lda #$00
	tax
	tay
	jmp decompress
	;
dont_skip_title
	ldy #$00
	ldx #$FF
	lda $FF07
	and #$40
	beq pal
	ldx #$F7
pal	cpx $FF1D
	bne *-3
	sty $FF19
	sty $FF15
	;
	ora #$18
	sta multi+1
	;
	lda #$0B	; screen off
	sta $FF06
	;
	lda $FF12
	and #$03	; keep lowest 2 bits (sound)	
	ora #title_target >> 10	; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #title_colmap >> 8	; color map
	sta $FF14
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$CC
	sta $FF0B
	;
	ldy #$00
	sty bitmap_dst
	lda #title_target >> 8
	sta bitmap_dst+1
	;
	ldx #$1F
	tya
clr1	sta (bitmap_dst),y
	iny
	bne clr1
	;
	inc bitmap_dst+1
	dex
	bpl clr1
	;
	ldx #3*40-1
	lda #$00
clr2	sta title_colmap + $400,x
	dex
	bpl clr2
	;
	asl $FF09
	;
	cli
	;
	;jmp docs_viewer	; uncomment for testing
	;
reveal_loop
	lda #$CA
	cmp $FF1D
	bne *-3
	;
	lda #$3B
	sta $FF06
	;
	;dec $FF19
column_1
	ldx #19
	jsr copy_one_column
column_2
	ldx #20
	jsr copy_one_column
	;inc $FF19
	;
	inc column_2+1
	dec column_1+1
	bmi reveal_done
	;
	jmp reveal_loop
	;
reveal_done
	jsr wait_loop
	;
erase_loop
	lda #$CA
	cmp $FF1D
	bne *-3
	;
	;dec $FF19
column_1e
	ldx #0
	jsr erase_one_column
column_2e
	ldx #39
	jsr erase_one_column
	;inc $FF19
	;
	dec column_2e+1
	inc column_1e+1
	lda column_1e+1
	cmp #20
	bne erase_loop
	;
	jmp docs_viewer

copy_one_column
	lda #$1E
	sta title_colmap + $400,x
	sta title_colmap + $428,x
	sta title_colmap + $450,x
	;
	stx bitmap_src
	lda #$00
	sta bitmap_src+1
	;
	asl bitmap_src
	rol bitmap_src+1
	asl bitmap_src
	rol bitmap_src+1
	asl bitmap_src
	rol bitmap_src+1
	;
	lda #(title_target) & 255
	clc
	adc bitmap_src
	sta bitmap_dst
	lda #(title_target) >> 8
	adc bitmap_src+1
	sta bitmap_dst+1
	;
	lda #(title_screen) & 255
	clc
	adc bitmap_src
	sta bitmap_src
	lda #(title_screen) >> 8
	adc bitmap_src+1
	sta bitmap_src+1
	;
	ldx #24
	;
coc_1	ldy #$00
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	;
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	iny
	lda (bitmap_src),y
	sta (bitmap_dst),y
	;
	lda bitmap_src
	clc
	adc #$40
	sta bitmap_src
	lda bitmap_src+1
	adc #$01
	sta bitmap_src+1 
	;
	lda bitmap_dst
	clc
	adc #$40
	sta bitmap_dst
	lda bitmap_dst+1
	adc #$01
	sta bitmap_dst+1 
	;
	dex
	bpl coc_1
	rts

erase_one_column
	lda #$00
	sta title_colmap + $400,x
	sta title_colmap + $428,x
	sta title_colmap + $450,x
	;
	stx bitmap_src
	lda #$00
	sta bitmap_src+1
	;
	asl bitmap_src
	rol bitmap_src+1
	asl bitmap_src
	rol bitmap_src+1
	asl bitmap_src
	rol bitmap_src+1
	;
	lda #(title_target) & 255
	clc
	adc bitmap_src
	sta bitmap_dst
	lda #(title_target) >> 8
	adc bitmap_src+1
	sta bitmap_dst+1
	;
	lda #(title_screen) & 255
	clc
	adc bitmap_src
	sta bitmap_src
	lda #(title_screen) >> 8
	adc bitmap_src+1
	sta bitmap_src+1
	;
	ldx #24
	;
eoc_1	ldy #$00
	tya
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	iny
	;
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	iny
	sta (bitmap_dst),y
	;
	lda bitmap_src
	clc
	adc #$40
	sta bitmap_src
	lda bitmap_src+1
	adc #$01
	sta bitmap_src+1 
	;
	lda bitmap_dst
	clc
	adc #$40
	sta bitmap_dst
	lda bitmap_dst+1
	adc #$01
	sta bitmap_dst+1 
	;
	dex
	bpl eoc_1
	rts
	;
	; --- wait for space or either joy fire release
	;
wait_loop
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	beq space_pressed
	;
	lda #$FF
	sta $FD30
	ldx #$FD
	stx $FF08
	lda $FF08
	cmp #$FF
	bne joy_pressed
	;
	lda #$FF
	sta $FD30
	ldx #$FB
	stx $FF08
	lda $FF08
	cmp #$FF
	beq wait_loop
	;
joy_pressed
	lda #$FF
	sta $FD30
	stx $FF08
	lda $FF08
	cmp #$FF
	bne joy_pressed
	rts
	;
space_pressed
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	beq space_pressed
	rts

irq1	pha
	;
	lda $FF07	; PAL/NTSC friendly
	and #$40
	ora #$08	; hires
	sta $FF07
	lda #$2E
	sta $FF16
	;
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$1B
	sta $FF0B
	;
	asl $FF09
	pla
	rti

irq2	pha
	;
multi	lda #$00				; self-mod
	sta $FF07				; turn on multicolor
	;
	lda #irq3 & 255
	sta $FFFE
	lda #irq3 >> 8
	sta $FFFF
	lda #$93
	sta $FF0B
	;
	asl $FF09
	pla
	rti
	
irq3	pha
	;
	lda #$31
	sta $FF16
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$CC
	sta $FF0B
	;
	asl $FF09
	;
	pla
	rti
	
	align $2000
title_screen
	include "title_gfx.asm"

irq_null
	asl $FF09
	rti
	
docs_viewer
	lda #$CB
	cmp $FF1D
	bne *-3
	;
	sei
	;
	lda #$0B				; screen off
	sta $FF06
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	;lda #$00
	;sta $FF15
	;sta $FF19
	;
	lda #$00
	sta $FF12
	lda #font >> 8
	sta $FF13
	;
	lda #$08
	sta $FF14
	;
	lda #$00
	tax
il2	sta $0C00,x
	sta $0D00,x
	sta $0E00,x
	sta $0F00,x
	dex
	bne il2
	;
	ldx #39
il1	lda #FOLDER_COLOR
	sta $0800,x
	sta $0800+1*40,x
	sta $0800+24*40,x
	lda #$47				; bottom char
	sta $0C00+24*40,x
	dex
	bpl il1
	;
	lda #$40
	sta $0C28
	sta $0C18
	lda #$44
	sta $0C4F
	lda #$45
	sta $0C26
	lda #$46
	sta $0C00 + 24 * 40
	lda #$48				; bottom right corner
	sta $0C00 + 24 * 40 + 39
	;
	ldx #37
	lda #$20
il5	sta $0C29,x
	dex
	bpl il5
	ldx #12
il6	sta $0C19,x
	dex
	bpl il6
	;
	ldx #11
	lda #$24
il7	sta $0C42,x
	dex
	bpl il7
	;
	lda #$50
	sta col
	sta chr
	lda #$08
	sta col+1
	ora #$04
	sta chr+1
	;
	ldx #21
il4	ldy #$00
	lda #FOLDER_COLOR
	sta (col),y
	lda #$42				; left side char
	sta (chr),y
	iny
	;
il3	lda #PAPER_COLOR
	sta (col),y
	lda #$20
	sta (chr),y
	iny
	cpy #39
	bne il3
	;
	lda #FOLDER_COLOR
	sta (col),y
	lda #$43				; right side char
	sta (chr),y
	;
	lda col
	clc
	adc #$28
	sta col
	sta chr
	bcc *+6
	inc col+1
	inc chr+1
	;
	dex
	bpl il4
	;
	; ---
	;
	lda #docs & 255
	sta src
	lda #docs >> 8
	sta src+1
	;
	lda #$00
	sta pg_num
	;
	jsr copy_screen
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	lda #$1B
	sta $FF06				; screen on
	;
main_loop
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard
	
copy_screen
	lda #($0C00+3*40+2 & 255)
	sta chr
	lda #($0C00+3*40+2 >> 8)
	sta chr+1
	;
	; ---
	;
	ldx #19
cl2	ldy #35
cl1	lda (src),y
	sta (chr),y
	dey
	bpl cl1
	;
	lda src
	clc
	adc #36
	sta src
	bcc *+4
	inc src+1
	;
	lda chr
	clc
	adc #40
	sta chr
	bcc *+4
	inc chr+1
	;
	dex
	bpl cl2
	rts
	
screen_up
	lda pg_num
	beq main_loop
	;
	lda src
	sec
	sbc #(40*36) & 255
	sta src
	lda src+1
	sbc #(40*36) >> 8
	sta src+1
	;
	jsr sync
	jsr page_in_step_1
	jsr sync
	jsr page_in_step_2
	jsr sync
	jsr page_in_step_3
	jsr sync
	jsr page_in_step_4
	jsr sync
	jsr page_in_step_5
	jsr sync
	jsr page_in_step_6
	jsr sync
	jsr page_in_step_7
	jsr sync
	jsr page_in_step_8
	;
	dec pg_num
	;
	jsr copy_screen
	jmp main_loop
	;	
screen_down
	lda pg_num
	cmp #6
	beq sd_1
	;
	jsr sync
	jsr page_away_step_1
	jsr sync
	jsr page_away_step_2
	jsr sync
	jsr page_away_step_3
	jsr sync
	jsr page_away_step_4
	jsr sync
	jsr page_away_step_5
	jsr sync
	jsr page_away_step_6
	jsr sync
	jsr page_away_step_7
	jsr sync
	jsr page_away_step_8
	;
	inc pg_num
	;
	jsr copy_screen
sd_1	jmp main_loop	
	
null
	rts

sync
	lda #$C2
	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	rts

m_copy_area	macro x_offset, y_offset, lines, chars
	lda src
	clc
	adc #(y_offset * 36 + x_offset) & 255
	sta src2
	lda src+1
	adc #(y_offset * 36 + x_offset) >> 8
	sta src2+1
	;
	lda #($0C00 + (3 + y_offset) * 40 + (2 + x_offset)) & 255
	sta chr
	lda #($0C00 + (3 + y_offset) * 40 + (2 + x_offset)) >> 8
	sta chr+1
	;
	ldx #lines-1
	ldy #chars-1
	jsr copy_area
	endm

page_away_step_1
	lda #($0C00 + 21 * 40 + 1) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 1) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 4) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 4) >> 8
	sta screen_dst+1
	;
	ldx #19 ; 20
	ldy #35 ; 36 chars
	;
	jsr page_away
	;
	m_copy_area 0, 0, 2, 36
	;
	lda #($0800 + 5 * 40 + 39) & 255
	sta col
	lda #($0800 + 5 * 40 + 39) >> 8
	sta col+1
	ldx #19
	jsr set_right_paper
	;
	m_copy_area 0, 2, 18, 2
	;  
	ldx #4
	ldy #40
	jsr set_bottom_paper
	;
	rts

page_away_step_2
	lda #($0C00 + 21 * 40 + 4) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 4) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 7) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 7) >> 8
	sta screen_dst+1
	;
	ldx #16 ; 17 lines
	ldy #32 ; 33 chars
	;
	jsr page_away
	;
	m_copy_area 2, 2, 3, 34
	m_copy_area 2, 5, 15, 3
	;
	ldx #4
	ldy #7
	jsr set_bottom_folder
	;
	lda #($0800 + 5 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 5 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_3
	lda #($0C00 + 21 * 40 + 7) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 7) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 10) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 10) >> 8
	sta screen_dst+1
	;
	ldx #13 ; 14 lines
	ldy #29 ; 30 chars
	;
	jsr page_away
	;
	m_copy_area 5, 5, 3, 31
	m_copy_area 5, 8, 12, 3
	;
	ldx #7
	ldy #10
	jsr set_bottom_folder
	;
	lda #($0800 + 8 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 8 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_4
	lda #($0C00 + 21 * 40 + 10) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 10) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 13) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 13) >> 8
	sta screen_dst+1
	;
	ldx #10 ; 11 lines
	ldy #26 ; 27 chars
	;
	jsr page_away
	;
	m_copy_area 8, 8, 3, 28
	m_copy_area 8, 11, 9, 3
	;
	ldx #10
	ldy #13
	jsr set_bottom_folder
	;
	lda #($0800 + 11 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 11 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_5
	lda #($0C00 + 21 * 40 + 13) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 13) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 16) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 16) >> 8
	sta screen_dst+1
	;
	ldx #7 ; 8 lines
	ldy #23 ; 24 chars
	;
	jsr page_away
	;
	m_copy_area 11, 11, 3, 25
	m_copy_area 11, 14, 6, 3
	;
	ldx #13
	ldy #16
	jsr set_bottom_folder
	;
	lda #($0800 + 14 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 14 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_6
	lda #($0C00 + 21 * 40 + 16) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 16) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 19) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 19) >> 8
	sta screen_dst+1
	;
	ldx #4 ; 5 lines
	ldy #20 ; 21 chars
	;
	jsr page_away
	;
	m_copy_area 14, 14, 3, 22
	m_copy_area 14, 17, 3, 3
	;
	ldx #16
	ldy #19
	jsr set_bottom_folder
	;
	lda #($0800 + 17 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 17 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_7
	lda #($0C00 + 21 * 40 + 19) & 255
	sta screen_src
	lda #($0C00 + 21 * 40 + 19) >> 8
	sta screen_src+1
	;
	lda #($0C00 + 24 * 40 + 22) & 255
	sta screen_dst
	lda #($0C00 + 24 * 40 + 22) >> 8
	sta screen_dst+1
	;
	ldx #1 ; 2 lines
	ldy #17 ; 18 chars
	;
	jsr page_away
	;
	m_copy_area 17, 17, 3, 19
	;m_copy_area 14, 17, 3, 3
	;
	ldx #19
	ldy #22
	jsr set_bottom_folder
	;
	lda #($0800 + 20 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 20 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #2
	jsr set_right_folder
	;
	rts

page_away_step_8
	ldx #22
	ldy #40
	jsr set_bottom_folder
	;
	lda #$48				; bottom right corner
	sta $0C00 + 24 * 40 + 39
	;
	lda #($0800 + 23 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 23 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #0
	jsr set_right_folder
	;
	rts

copy_one_char macro
	lda (screen_src),y
	sta (screen_dst),y
	dey
	endm
	
page_away
	sty pa_1+1
	;
pa_1	ldy #$00
	;
	copy_one_char				; partially unrolled loop (for speed)
	copy_one_char
	copy_one_char
	copy_one_char
	copy_one_char
	;
	copy_one_char
	copy_one_char
	copy_one_char
	copy_one_char
	copy_one_char
	;
	copy_one_char
	copy_one_char
	copy_one_char
	copy_one_char
	copy_one_char
	;
pa_2	lda (screen_src),y
	sta (screen_dst),y
	dey
	bpl pa_2
	;
	lda screen_src
	sec
	sbc #40
	sta screen_src
	bcs *+4
	dec screen_src+1
	;
	lda screen_dst
	sec
	sbc #40
	sta screen_dst
	bcs *+4
	dec screen_dst+1
	;
	dex
	bpl pa_1
	rts

copy_area
	sty ca2+1
	;
ca2	ldy #0
ca1	lda (src2),y
	sta (chr),y
	dey
	bpl ca1
	;
	lda src2
	clc
	adc #36
	sta src2
	bcc *+4
	inc src2+1
	;
	lda chr
	clc
	adc #40
	sta chr
	bcc *+4
	inc chr+1
	;
	dex
	bpl ca2
	rts

set_bottom_paper
	sty sbp_1+1
	lda #PAPER_COLOR
sbp_2	sta $0800 + 24 * 40,x
	inx
sbp_1	cpx #0
	bne sbp_2
	rts

set_bottom_folder
	sty sbf_1+1
sbf_2	lda #PAPER_COLOR
	sta $0800 + 23 * 40,x
	lda #$20
	sta $0C00 + 23 * 40,x
	lda #FOLDER_COLOR
	sta $0800 + 24 * 40,x
	lda #$47				; bottom char
	sta $0C00 + 24 * 40,x
	inx
sbf_1	cpx #0
	bne sbf_2
	rts

set_right_paper
	ldy #$00
srp_1	lda #PAPER_COLOR
	sta (col),y
	;
	lda col
	clc
	adc #40
	sta col
	bcc *+4
	inc col+1
	;
	dex
	bpl srp_1
	rts

set_right_folder
	ldy #$00
srf_1	lda #PAPER_COLOR
	sta (col),y
	lda #$20
	sta (chr),y
	iny
	lda #FOLDER_COLOR
	sta (col),y
	lda #$43				; right side char
	sta (chr),y
	dey
	;
	lda col
	clc
	adc #40
	sta col
	sta chr
	bcc *+6
	inc col+1
	inc chr+1
	;
	dex
	bpl srf_1
	rts

m_copy_area_2	macro x_offset, y_offset, lines, chars
	lda src
	sta src2  
	lda src+1
	sta src2+1
	;
	lda #($0C00 + (3 + y_offset) * 40 + (2 + x_offset)) & 255
	sta chr
	lda #($0C00 + (3 + y_offset) * 40 + (2 + x_offset)) >> 8
	sta chr+1
	;
	ldx #lines-1
	ldy #chars-1
	jsr copy_area
	endm

page_in_step_1
	m_copy_area_2 21, 21, 1, 17
	;
	lda #($0C00 + 23 * 40) & 255
	sta chr
	lda #($0C00 + 23 * 40) >> 8
	sta chr+1
	;
	ldy #22
	ldx #0
	jsr paper_top
	;
	lda #($0C00 + 23 * 40 + 22) & 255
	sta chr
	lda #($0C00 + 23 * 40 + 22) >> 8
	sta chr+1
	ldx #1
	jsr paper_left
	;
	rts

page_in_step_2
	m_copy_area_2 18, 18, 4, 20
	;
	lda #($0C00 + 20 * 40) & 255
	sta chr
	lda #($0C00 + 20 * 40) >> 8
	sta chr+1
	;
	ldy #19
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 20 * 40 + 19) & 255
	sta chr
	lda #($0C00 + 20 * 40 + 19) >> 8
	sta chr+1
	ldx #4
	jsr paper_left
	;
	rts

page_in_step_3
	m_copy_area_2 15, 15, 7, 23
	;
	lda #($0C00 + 17 * 40) & 255
	sta chr
	lda #($0C00 + 17 * 40) >> 8
	sta chr+1
	;
	ldy #16
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 17 * 40 + 16) & 255
	sta chr
	lda #($0C00 + 17 * 40 + 16) >> 8
	sta chr+1
	ldx #7
	jsr paper_left
	;
	rts

page_in_step_4
	m_copy_area_2 12, 12, 10, 26
	;
	lda #($0C00 + 14 * 40) & 255
	sta chr
	lda #($0C00 + 14 * 40) >> 8
	sta chr+1
	;
	ldy #13
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 14 * 40 + 13) & 255
	sta chr
	lda #($0C00 + 14 * 40 + 13) >> 8
	sta chr+1
	ldx #10
	jsr paper_left
	;
	rts

page_in_step_5
	m_copy_area_2 9, 9, 13, 29
	;
	lda #($0C00 + 11 * 40) & 255
	sta chr
	lda #($0C00 + 11 * 40) >> 8
	sta chr+1
	;
	ldy #10
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 11 * 40 + 10) & 255
	sta chr
	lda #($0C00 + 11 * 40 + 10) >> 8
	sta chr+1
	ldx #13
	jsr paper_left
	;
	rts

page_in_step_6
	m_copy_area_2 6, 6, 16, 32
	;
	lda #($0C00 + 8 * 40) & 255
	sta chr
	lda #($0C00 + 8 * 40) >> 8
	sta chr+1
	;
	ldy #7
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 8 * 40 + 7) & 255
	sta chr
	lda #($0C00 + 8 * 40 + 7) >> 8
	sta chr+1
	ldx #16
	jsr paper_left
	;
	rts

page_in_step_7
	m_copy_area_2 3, 3, 19, 35
	;
	lda #($0C00 + 5 * 40) & 255
	sta chr
	lda #($0C00 + 5 * 40) >> 8
	sta chr+1
	;
	ldy #4
	ldx #2
	jsr paper_top
	;
	lda #($0C00 + 5 * 40 + 4) & 255
	sta chr
	lda #($0C00 + 5 * 40 + 4) >> 8
	sta chr+1
	ldx #19
	jsr paper_left
	;
	rts

page_in_step_8
	lda #($0800 + 5 * 40 + 38) & 255
	sta col 
	sta chr
	lda #($0800 + 5 * 40 + 38) >> 8
	sta col+1
	ora #$04
	sta chr+1
	ldx #18
	jsr set_right_folder
	;
	ldx #34
pis8_1	lda #FOLDER_COLOR
	sta $0800 + 24 * 40 + 4,x
	lda #$47				; bottom char
	sta $0C00 + 24 * 40 + 4,x
	lda #$20
	sta $0C00 + 23 * 40 + 4,x
	dex
	bpl pis8_1
	;
	lda #FOLDER_COLOR
	sta $0800 + 24 * 40 + 39
	lda #$48				; bottom right corner
	sta $0C00 + 24 * 40 + 39
	;
	rts

paper_top
	lda chr
	sta col
	lda chr+1
	and #$FB
	sta col+1
	;
	lda #$20
	sta $0C00 + 40 * 24,y
	;
	sty ptl_3+1
	;
ptl_1	lda #PAPER_COLOR
	sta (col),y
	sta $0800 + 40 * 24,y
	lda #$20
	sta (chr),y
	iny
	cpy #40
	bne ptl_1
	;
	cpx #$00
	beq ptl_2
	;
	ldy #79
	lda #PAPER_COLOR
	sta (col),y
	ldy #119
	sta (col),y
	;
ptl_3	lda #$00
	clc
	adc #40
	tay
	lda #$20
	sta (chr),y
	;
	tya
	clc
	adc #40
	tay
	lda #$20
	sta (chr),y
	;
ptl_2	rts

paper_left
	ldy #$00
pl_1	lda #$20
	sta (chr),y
	;
	lda chr
	clc
	adc #40
	sta chr
	bcc *+4
	inc chr+1
	;
	dex
	bpl pl_1
	;
	lda chr+1
	and #$FB
	sta chr+1
	lda #PAPER_COLOR
	sta (chr),y
	;
	rts
	;
	; ---
	;
exit	sei
	sta $FF3F
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	ldx #$00
	txa
fl0	sta $0800,x
	sta $0900,x
	sta $0A00,x
	sta $0B00,x
	inx
	bne fl0
	;
	ldx #irq_end-irq
fl1	lda irq,x
	sta $FC00,x
	dex
	bpl fl1
	;
	ldx #$00
fl2	lda decompress_charset,x
	sta $0F00,x
	lda decompress_charset_2,x
	sta $0C00,x
	lda #$00
	sta $0D00,x
	sta $0E00,x
	inx
	bne fl2
	;
	ldx #7
fl3	txa
	ora #$80
	sta $0DA0,x
	lda #$61
	sta $09A0,x
	dex
	bpl fl3
	;
	ldx #11
fl4	txa
	clc
	adc #$88
	sta $0DC6,x
	lda #$61
	sta $09C6,x
	dex
	bpl fl4
	;
	ldx #5
fl5	txa
	clc
	adc #$94
	sta $0DF1,x
	lda #$61
	sta $09F1,x
	dex
	bpl fl5
	;
	ldx #3  
fl6	lda $FF07
	and #$40
	beq pal2
	;
	lda digits_ntsc,x
	bne fl7 
	;
pal2	lda digits_pal,x
fl7	sta $0E1A,x
	txa
	clc
	adc #$9A
	sta $0E42,x
	lda #$61
	sta $0A1A,x
	sta $0A42,x
	dex
	bpl fl6
	;
	lda #$00
	sta $FF12
	lda #$08
	sta $FF13
	;
	lda $FF07
	and #$40
	ora #$88
	sta $FF07
	;
	lda #$CC
	sta $FF0B
	lda #$FC
	sta $FFFF
	lda #$00
	sta $FFFE
	tax
	tay
	cli
	jmp decompress

	cmap "0",$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9
digits_pal
	db "0170"
digits_ntsc
	db "0223"
	cmap

decompress_charset
	db $00,$3C,$42,$42,$42,$42,$3C,$00
	db $00,$08,$18,$08,$08,$08,$3E,$00
	db $00,$3C,$42,$04,$18,$20,$7E,$00
	db $00,$3C,$42,$1C,$02,$42,$3C,$00
	db $00,$04,$0C,$14,$24,$7E,$04,$00
	db $00,$7E,$40,$7C,$02,$42,$3C,$00
	db $00,$3C,$40,$7C,$42,$42,$3C,$00
	db $00,$7E,$04,$08,$10,$20,$40,$00
	db $00,$3C,$42,$3C,$42,$42,$3C,$00
	db $00,$3C,$42,$42,$3E,$02,$3C,$00

decompress_charset_2
	db $00,$39,$45,$45,$7D,$45,$45,$00
	db $00,$E7,$14,$14,$E7,$04,$04,$00
	db $00,$9E,$51,$51,$9E,$12,$11,$00
	db $00,$38,$45,$45,$45,$45,$39,$00
	db $00,$E3,$14,$14,$F4,$14,$13,$00
	db $00,$91,$51,$11,$1F,$51,$91,$00
	db $00,$50,$58,$54,$52,$51,$50,$00
	db $00,$9C,$A2,$A0,$A6,$A2,$9E,$00

	db $00,$0F,$02,$02,$02,$02,$02,$00
	db $00,$A2,$22,$22,$3E,$22,$22,$00
	db $00,$F8,$80,$F0,$80,$80,$F8,$00
	db $00,$3E,$20,$3C,$20,$20,$3E,$00
	db $00,$71,$8A,$8A,$FA,$8A,$89,$00
	db $00,$C8,$28,$08,$68,$28,$EF,$00
	db $00,$3E,$20,$3C,$20,$20,$BE,$00
	db $80,$9C,$20,$1C,$02,$22,$1C,$00
	db $00,$08,$0C,$0A,$09,$08,$08,$00
	db $00,$5F,$50,$5E,$50,$D0,$5F,$00
	db $00,$39,$40,$38,$04,$44,$38,$00
	db $00,$F0,$40,$40,$40,$40,$40,$00

	db $00,$3C,$22,$22,$22,$22,$3C,$00
	db $00,$9C,$A0,$9C,$82,$A2,$9C,$00
	db $00,$F9,$22,$22,$23,$22,$22,$00
	db $00,$C8,$2C,$2A,$E9,$28,$28,$00
	db $00,$4E,$51,$50,$50,$D1,$4E,$00
	db $00,$7C,$40,$78,$40,$40,$7C,$00

	db $00,$8B,$DA,$AB,$8A,$8B,$00,$00
	db $00,$DF,$04,$84,$04,$C4,$00,$00
	db $00,$7B,$42,$73,$42,$7A,$00,$00
	db $00,$C7,$28,$C6,$41,$2E,$00,$00

irq
	pha
	txa
	pha
	asl $FF09
	;
	ldx #$03
i2	lda $0E1A,x
	sec
	sbc #$01
	cmp #$DF
	bne i1
	;
	lda #$E9
	sta $0E1A,x
	dex
	bpl i2
	;
i1	sta $0E1A,x
	;
	pla
	tax
	pla
	rti
irq_end
	
	include "keyboard.asm"
	include "key_constants.asm"
	
key_table
	dw null
	;
	dw $0104, screen_up
	dw $0204, screen_down
	dw $4004, exit
	;
	dw $0102, screen_up
	dw $0202, screen_down
	dw $8002, exit
	;
	dw KEY_CURSOR_UP, screen_up
	dw KEY_CURSOR_DOWN, screen_down
	dw KEY_ESC, exit
	dw KEY_RUN_STOP, exit
	dw KEY_RETURN, exit
	dw KEY_SPACE, exit
	dw 0

docs	
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "`",$22
	cmap "~",$23
	include "docs.asm"
	cmap
	
	align $0800
font
	include "font.asm"
;eof