	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

; keyboard
keyb_ptr		= $C4		; 16 bit
keyb_lastkey		= $C6
keyb_repeatcnt		= $C7
keyb_shift		= $C8
keyb_repeat_init	= 20		; constant
keyb_repeat		= 4		; constant

col	= $D0
chr	= $D2
src	= $D4
pg_num	= $D6
	
start
	sei
	sta $ff3f
	;
	lda #$1B
	sta $FF06
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	lda #$00
	sta $FF15
	sta $FF19
	;
	lda #$00
	sta $FF12
	lda #font >> 8
	sta $FF13
	;
	lda #$00
	tax
il2	sta $0C00,x
	sta $0D00,x
	sta $0E00,x
	sta $0F00,x
	dex
	bne il2
	;
	ldx #39
il1	lda #$68
	sta $0800,x
	sta $0800+1*40,x
	sta $0800+24*40,x
	lda #$47
	sta $0C00+24*40,x
	dex
	bpl il1
	;
	lda #$40
	sta $0C28
	sta $0C18
	lda #$44
	sta $0C4F
	lda #$45
	sta $0C26
	lda #$46
	sta $0C00+24*40
	lda #$48
	sta $0C00+24*40+39
	;
	ldx #37
	lda #$20
il5	sta $0C29,x
	dex
	bpl il5
	ldx #12
il6	sta $0C19,x
	dex
	bpl il6
	;
	ldx #11
	lda #$24
il7	sta $0C42,x
	dex
	bpl il7
	;
	lda #$50
	sta col
	sta chr
	lda #$08
	sta col+1
	ora #$04
	sta chr+1
	;
	ldx #21
il4	ldy #$00
	lda #$68
	sta (col),y
	lda #$42
	sta (chr),y
	iny
	;
il3	lda #$71
	sta (col),y
	lda #$20
	sta (chr),y
	iny
	cpy #39
	bne il3
	;
	lda #$68
	sta (col),y
	lda #$43
	sta (chr),y
	;
	lda col
	clc
	adc #$28
	sta col
	sta chr
	bcc *+6
	inc col+1
	inc chr+1
	;
	dex
	bpl il4
	;
	; ---
	;
	lda #docs & 255
	sta src
	lda #docs >> 8
	sta src+1
	;
	lda #$00
	sta pg_num
	;
	jsr copy_screen
	;
main_loop
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard
	
copy_screen
	lda #($0C00+3*40+2 & 255)
	sta chr
	lda #($0C00+3*40+2 >> 8)
	sta chr+1
	;
	; ---
	;
	ldx #19
cl2	ldy #35
cl1	lda (src),y
	sta (chr),y
	dey
	bpl cl1
	;
	lda src
	clc
	adc #36
	sta src
	bcc *+4
	inc src+1
	;
	lda chr
	clc
	adc #40
	sta chr
	bcc *+4
	inc chr+1
	;
	dex
	bpl cl2
	rts
	
screen_up
	lda pg_num
	beq main_loop
	;
	lda src
	sec
	sbc #(40*36) & 255
	sta src
	lda src+1
	sbc #(40*36) >> 8
	sta src+1
	;
	dec pg_num
	;
	jsr copy_screen
	jmp main_loop
	;	
screen_down
	lda pg_num
	cmp #6
	beq main_loop
	;
	inc pg_num
	;
	jsr copy_screen
	jmp main_loop	
	
null
	rts

exit
	jmp $FFF6
	
	include "keyboard.asm"
	include "key_constants.asm"
	
key_table
	dw null
	;
	dw $0104, screen_up
	dw $0204, screen_down
	dw $4004, exit
	;
	dw $0102, screen_up
	dw $0202, screen_down
	dw $8002, exit
	;
	dw KEY_CURSOR_UP, screen_up
	dw KEY_CURSOR_DOWN, screen_down
	dw KEY_ESC, exit
	dw KEY_RUN_STOP, exit
	dw KEY_RETURN, exit
	dw KEY_SPACE, exit
	dw 0

docs	
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "`",$22
	cmap "~",$23
	include "docs.asm"
	cmap
	
	align $0800
font
	include "font.asm"
;eof